SoConcatenate(3)

NAME
SoConcatenate - The SoConcatenate class is used to concatenate several inputs into one output.

SYNOPSIS

#include <Inventor/engines/SoConcatenate.h>

Inherits SoEngine.

  Public Types
enum { NUMINPUTS = 10 }

  Public Member Functions
virtual SoType getTypeId (void) const
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.
virtual const SoFieldData * getFieldData (void) const
virtual const SoEngineOutputData * getOutputData (void) const
SoConcatenate (SoType inputType)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void * createInstance (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoMField * input [NUMINPUTS]
SoEngineOutput * output

  Static Protected Member Functions
static const SoFieldData ** getInputDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoConcatenate class is used to concatenate several inputs into one output. Takes all the values from the 10 input multivalue fields in turn and concatenates them into the multivalue output.

Note that this engine's output field deviates a little from the 'standard' output mechanism of the majority of engine classes: the SoConcatenate::output is not a permanent SoEngineOutput instance, but a pointer to a SoEngineOutput instance. The reason for this is that it is necessary to allocate the output field dynamically to make it match what the SoConcatenate::input is connected to since the type of the SoConcatenate::output always should be the same as the type of the SoConcatenate::input.

The file format for this field is a bit special. Note the leading type specification, which is not necessary for most other field types:

Concatenate {
  type <multivaluefieldtype>
  [...fields...]
}

Constructor & Destructor Documentation

  SoConcatenate::SoConcatenate (SoType type)
Constructor. The type of the input/output is specified in type.

Member Function Documentation

  virtual SoType SoConcatenate::getTypeId (void) const [virtual]

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting. Usage example:

void foo(SoNode * node)
{
  if (node->getTypeId() == SoFile::getClassTypeId()) {
    SoFile * filenode = (SoFile *)node;  // safe downward cast, knows the type
  }
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the predefined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the top level superclasses for the various class groups.

Implements SoBase.

  virtual const SoFieldData * SoConcatenate::getFieldData (void) const [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  virtual const SoEngineOutputData * SoConcatenate::getOutputData (void) const [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implements SoEngine.

Member Data Documentation

  SoMField * SoConcatenate::input[10]
The multivalue input fields which we will concatenate into the output.

  SoEngineOutput * SoConcatenate::output
(SoMField) This is the field output containing the concatenated values of all the input fields.

The type of the field will of course match the type of the input field.

Author

Generated automatically by Doxygen for Coin from the source code.